gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Interfaces.Editable

Contents

- Exported types
- Methods
  - copyClipboard
  - cutClipboard
  - deleteSelection
  - deleteText
  - getChars
  - getEditable
  - getPosition
  - getSelectionBounds
  - insertText
  - pasteClipboard
  - selectRegion
  - setEditable
  - setPosition
- Signals
  - changed
  - deleteText
  - insertText

Description

The `Editable` interface is an interface which should be implemented by text editing widgets, such as `Entry` and `SpinButton`. It contains functions for generically manipulating an editable widget, a large number of action signals used for key bindings, and several signals that an application can connect to to modify the behavior of a widget.

As an example of the latter usage, by connecting the following handler to Editable::insertText, an application can convert all entry into a widget into uppercase.

## Forcing entry to uppercase.

### C code

    #include <ctype.h>;

    void
    insert_text_handler (GtkEditable *editable,
                         const gchar *text,
                         gint         length,
                         gint        *position,
                         gpointer     data)
    {
      gchar *result = g_utf8_strup (text, length);

      g_signal_handlers_block_by_func (editable,
                                   (gpointer) insert_text_handler, data);
      gtk_editable_insert_text (editable, result, length, position);
      g_signal_handlers_unblock_by_func (editable,
                                         (gpointer) insert_text_handler, data);

      g_signal_stop_emission_by_name (editable, "insert_text");

      g_free (result);
    }

Synopsis

- newtype Editable = Editable (ManagedPtr Editable)
- class (GObject o, IsDescendantOf Editable o) => IsEditable o
- toEditable :: (MonadIO m, IsEditable o) => o -> m Editable
- editableCopyClipboard :: (HasCallStack, MonadIO m, IsEditable a) => a -> m ()
- editableCutClipboard :: (HasCallStack, MonadIO m, IsEditable a) => a -> m ()
- editableDeleteSelection :: (HasCallStack, MonadIO m, IsEditable a) => a -> m ()
- editableDeleteText :: (HasCallStack, MonadIO m, IsEditable a) => a -> Int32 -> Int32 -> m ()
- editableGetChars :: (HasCallStack, MonadIO m, IsEditable a) => a -> Int32 -> Int32 -> m Text
- editableGetEditable :: (HasCallStack, MonadIO m, IsEditable a) => a -> m Bool
- editableGetPosition :: (HasCallStack, MonadIO m, IsEditable a) => a -> m Int32
- editableGetSelectionBounds :: (HasCallStack, MonadIO m, IsEditable a) => a -> m (Bool, Int32, Int32)
- editableInsertText :: (HasCallStack, MonadIO m, IsEditable a) => a -> Text -> Int32 -> Int32 -> m Int32
- editablePasteClipboard :: (HasCallStack, MonadIO m, IsEditable a) => a -> m ()
- editableSelectRegion :: (HasCallStack, MonadIO m, IsEditable a) => a -> Int32 -> Int32 -> m ()
- editableSetEditable :: (HasCallStack, MonadIO m, IsEditable a) => a -> Bool -> m ()
- editableSetPosition :: (HasCallStack, MonadIO m, IsEditable a) => a -> Int32 -> m ()
- type EditableChangedCallback = IO ()
- afterEditableChanged :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableChangedCallback) -> m SignalHandlerId
- onEditableChanged :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableChangedCallback) -> m SignalHandlerId
- type EditableDeleteTextCallback = Int32 -> Int32 -> IO ()
- afterEditableDeleteText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableDeleteTextCallback) -> m SignalHandlerId
- onEditableDeleteText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableDeleteTextCallback) -> m SignalHandlerId
- type EditableInsertTextCallback = Text -> Int32 -> Int32 -> IO Int32
- afterEditableInsertText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableInsertTextCallback) -> m SignalHandlerId
- onEditableInsertText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableInsertTextCallback) -> m SignalHandlerId

# Exported types

newtype Editable Source #

Memory-managed wrapper type.

Constructors

Editable (ManagedPtr Editable) |

#### Instances

Instances details

Eq Editable Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable Methods (==) :: Editable -> Editable -> Bool Source # (/=) :: Editable -> Editable -> Bool Source #
GObject Editable Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable
ManagedPtrNewtype Editable Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable Methods toManagedPtr :: Editable -> ManagedPtr Editable Source #
TypedObject Editable Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable Methods glibType :: IO GType Source #
HasParentTypes Editable Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable
IsGValue (Maybe Editable) Source # | Convert `Editable` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Interfaces.Editable Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Editable -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Editable) Source #
type ParentTypes Editable Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable type ParentTypes Editable = '[Object]

class (GObject o, IsDescendantOf Editable o) => IsEditable o Source #

Type class for types which can be safely cast to `Editable`, for instance with `toEditable`.

#### Instances

Instances details

(GObject o, IsDescendantOf Editable o) => IsEditable o Source # |
Instance details Defined in GI.Gtk.Interfaces.Editable

toEditable :: (MonadIO m, IsEditable o) => o -> m Editable Source #

Cast to `Editable`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, copyClipboard, cutClipboard, deleteSelection, deleteText, forceFloating, freezeNotify, getv, insertText, isFloating, notify, notifyByPspec, pasteClipboard, ref, refSink, runDispose, selectRegion, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getChars, getData, getEditable, getPosition, getProperty, getQdata, getSelectionBounds.

#### Setters

setData, setDataFull, setEditable, setPosition, setProperty.

## copyClipboard

editableCopyClipboard Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m () |

Copies the contents of the currently selected content in the editable and puts it on the clipboard.

## cutClipboard

editableCutClipboard Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m () |

Removes the contents of the currently selected content in the editable and puts it on the clipboard.

## deleteSelection

editableDeleteSelection Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m () |

Deletes the currently selected text of the editable. This call doesn’t do anything if there is no selected text.

## deleteText

editableDeleteText Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> Int32 | `startPos`: start position
-> Int32 | `endPos`: end position
-> m () |

Deletes a sequence of characters. The characters that are deleted are those characters at positions from `startPos` up to, but not including `endPos`. If `endPos` is negative, then the characters deleted are those from `startPos` to the end of the text.

Note that the positions are specified in characters, not bytes.

## getChars

editableGetChars Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> Int32 | `startPos`: start of text
-> Int32 | `endPos`: end of text
-> m Text | Returns: a pointer to the contents of the widget as a string. This string is allocated by the `Editable` implementation and should be freed by the caller.

Retrieves a sequence of characters. The characters that are retrieved are those characters at positions from `startPos` up to, but not including `endPos`. If `endPos` is negative, then the characters retrieved are those characters from `startPos` to the end of the text.

Note that positions are specified in characters, not bytes.

## getEditable

editableGetEditable Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m Bool | Returns: `True` if `editable` is editable.

Retrieves whether `editable` is editable. See `editableSetEditable`.

## getPosition

editableGetPosition Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m Int32 | Returns: the cursor position

Retrieves the current position of the cursor relative to the start of the content of the editable.

Note that this position is in characters, not in bytes.

## getSelectionBounds

editableGetSelectionBounds Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m (Bool, Int32, Int32) | Returns: `True` if an area is selected, `False` otherwise

Retrieves the selection bound of the editable. start_pos will be filled with the start of the selection and `endPos` with end. If no text was selected both will be identical and `False` will be returned.

Note that positions are specified in characters, not bytes.

## insertText

editableInsertText Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> Text | `newText`: the text to append
-> Int32 | `newTextLength`: the length of the text in bytes, or -1
-> Int32 | `position`: location of the position text will be inserted at
-> m Int32 |

Inserts `newTextLength` bytes of `newText` into the contents of the widget, at position `position`.

Note that the position is in characters, not in bytes. The function updates `position` to point after the newly inserted text.

## pasteClipboard

editablePasteClipboard Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> m () |

Pastes the content of the clipboard to the current position of the cursor in the editable.

## selectRegion

editableSelectRegion Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> Int32 | `startPos`: start of region
-> Int32 | `endPos`: end of region
-> m () |

Selects a region of text. The characters that are selected are those characters at positions from `startPos` up to, but not including `endPos`. If `endPos` is negative, then the characters selected are those characters from `startPos` to the end of the text.

Note that positions are specified in characters, not bytes.

## setEditable

editableSetEditable Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> Bool | `isEditable`: `True` if the user is allowed to edit the text in the widget
-> m () |

Determines if the user can edit the text in the editable widget or not.

## setPosition

editableSetPosition Source #

Arguments

:: (HasCallStack, MonadIO m, IsEditable a) |
=> a | `editable`: a `Editable`
-> Int32 | `position`: the position of the cursor
-> m () |

Sets the cursor position in the editable to the given value.

The cursor is displayed before the character with the given (base 0) index in the contents of the editable. The value must be less than or equal to the number of characters in the editable. A value of -1 indicates that the position should be set after the last character of the editable. Note that `position` is in characters, not in bytes.

# Signals

## changed

type EditableChangedCallback = IO () Source #

The changed signal is emitted at the end of a single user-visible operation on the contents of the `Editable`.

E.g., a paste operation that replaces the contents of the selection will cause only one signal emission (even though it is implemented by first deleting the selection, then inserting the new content, and may cause multiple notify text signals to be emitted).

afterEditableChanged :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the changed signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after editable #changed callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onEditableChanged :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the changed signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on editable #changed callback

## deleteText

type EditableDeleteTextCallback Source #

Arguments

= Int32 | `startPos`: the starting position
-> Int32 | `endPos`: the end position
-> IO () |

This signal is emitted when text is deleted from the widget by the user. The default handler for this signal will normally be responsible for deleting the text, so by connecting to this signal and then stopping the signal with `signalStopEmission`, it is possible to modify the range of deleted text, or prevent it from being deleted entirely. The `startPos` and `endPos` parameters are interpreted as for `editableDeleteText`.

afterEditableDeleteText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableDeleteTextCallback) -> m SignalHandlerId Source #

Connect a signal handler for the deleteText signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after editable #deleteText callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onEditableDeleteText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableDeleteTextCallback) -> m SignalHandlerId Source #

Connect a signal handler for the deleteText signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on editable #deleteText callback

## insertText

type EditableInsertTextCallback Source #

Arguments

= Text | `newText`: the new text to insert
-> Int32 | `newTextLength`: the length of the new text, in bytes, or -1 if new_text is nul-terminated
-> Int32 | `position`: the position, in characters, at which to insert the new text. this is an in-out parameter. After the signal emission is finished, it should point after the newly inserted text.
-> IO Int32 |

This signal is emitted when text is inserted into the widget by the user. The default handler for this signal will normally be responsible for inserting the text, so by connecting to this signal and then stopping the signal with `signalStopEmission`, it is possible to modify the inserted text, or prevent it from being inserted entirely.

afterEditableInsertText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableInsertTextCallback) -> m SignalHandlerId Source #

Connect a signal handler for the insertText signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after editable #insertText callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onEditableInsertText :: (IsEditable a, MonadIO m) => a -> ((?self :: a) => EditableInsertTextCallback) -> m SignalHandlerId Source #

Connect a signal handler for the insertText signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on editable #insertText callback